;PROMPTER.ASM IS THE PROMPTER OPERATING SYSTEM
;WRITTEN 5/10/84	COPYRIGHT (C) BD SOLLISH 1984
;USER PROGRAM IS IN PURE TEXT FORM
;*** 8 MHZ CLOCK***
	;REV 1.3
	;***TEXT STARTS AT 2000H***
	;LOWER CASE TEXT IS DISPLAYED AS UPPER CASE INVERSE

	ORG 100H

;SYSTEM EQUATES

	RAMTP	EQU	2000H	;TOP OF SYSTEM RAM
	VRAM	EQU	1000H	;ORIGIN OF 2K VIDEO RAM
	SRAM	EQU	1800H	;ORIGIN OF 2K SYSTEM RAM
	SROM	EQU	0000H	;ORIGIN OF 4K SYSTEM ROM
	AROM	EQU	2000H	;ORIGIN OF 56K APPLICATION ROM
	STLIN	EQU	SRAM	;STORED LINE START ADDRESS
	CCNT	EQU	SRAM+2	;STORED CHARACTER COUNT
	CPAGE	EQU	SRAM+3	;STORED PAGE START ADDRESS
	CANSR	EQU	SRAM+5	;STORED ANSWER ADDRESS
	CHAR	EQU	SRAM+7	;
	TEMP	EQU	SRAM+9	;SCRATCHPAD ADDRESS
	SCRAD	EQU	SRAM+11	;STORED SCREEN ADDRESS OF #
	PMAX	EQU	SRAM+100H	;MAXIMUM PAGE COUNT
	PAGES	EQU	PMAX+1	;PAGE ADDRESS TABLE
	AMAX	EQU	SRAM+200H	;MAXIMUM ANSWER COUNT
	ANSRS	EQU	AMAX+1	;ANSWER KEY INDEX
	ANSR0	EQU	SRAM+300H	;START OF ANSWER KEYS

	TEXT	EQU	2000H	

	KPORT	EQU	0F8H	;KEYBOARD PORT AND BANK SELECT

	CADDR	EQU	0CFH	;CRTC ADDRESS REGISTER
	CDTA	EQU	0DFH	;CRTC DATA REGISTER
	LEN	EQU	40	;LINE LENGTH

	EOF	EQU	1AH	;ASCII END OF FILE

PROMPT:	LXI	SP,RAMTP
	CALL	CRTC		;INITIALIZE CRTC
	CALL	ERASE		;ERASE SCREEN
	CALL	ERAS1		;ERASE SYSTEM RAM
	CALL	PSCAN		;SETUP PAGE TABLES
	CALL	ASCAN		;SETUP ANSWER KEYS
	JMP	GO		;DISPLAY TEXT AND GO!
;END OF MAIN PROGRAM-SUBROUTINES FOLLOW


;***CRTC INITIALIZATION HITACHI HD68B45 CONTROLLER
;DISPLAY PARAMETERS 50/60 HZ SELECTABLE
;	DOT CLOCK FREQUENCY: 8.0 MHZ
;	CHARACTER FREQUENCY: 1 MHZ
;	HORIZONTAL LINE FREQUENCY: 15.625 KHZ
;	HORIZONTAL RETRACE TIME: 24  MICROSECONDS
;	HORIZONTAL SYNC PULSE WIDTH: 5 MICROSECONDS
;	CHARACTERS/LINE: 64 TOTAL, 40 DISPLAYED
;	NUMBER OF LINES: 25 DISPLAYED 
;	60 HZ OPERATION
;		FRAME RATE: 60.1 HZ
;		VERTICAL RETRACE TIME:2.24 MILLISECONDS
;		VERTICAL SYNC PULSE WIDTH: 448 MICROSECONDS
;		TOTAL LINES: 28 + 8 RASTERS
;	50 HZ OPERATION
;		FRAME RATE: 50.1 HZ
;		VERTICAL RETRACE TIME:5.57 MILLISECONDS
;		VERTICAL SYNC PULSE WIDTH: 448 MICROSECONDS
;		TOTAL LINES: 34 + 6 RASTERS

;		CRTC REGISTER ASSIGNMENTS (60 HZ)

;	R0	HORIZONTAL TOTAL CHARS		63(64-1)
;	R1	HORIZONTAL DISPL CHARS		40
;	R2	HORIZONTAL SYNC POSITION	49 (50-1)
;	R3	SYNC WIDTH (7 RASTERS,5 CHARS)	75H
;	R4	VERTICAL TOTAL 60 HZ		27 (28-1)
;		VERTICAL TOTAL 50 HZ		33 (34-1)
;	R5	VERTICAL TOTAL ADJ 60 HZ	08
;		VERTICAL TOTAL ADJ 50 HZ	06
;	R6	VERTICAL DISPLAYED LINES	25
;	R7	VERTICAL SYNC POSITION 60 HZ	26 (27-1)
;		VERTICAL SYNC POSITION 50 HZ	30 (31-1)
;	R8	INTERLACE AND SKEW		00
;	R9	MAX RASTER ADDRESS (9 RASTERS)	08
;	R10	CURSOR START RASTER		20H
;	R11	CURSOR END RASTER		09
;	R12	VIDEO RAM START ADDRESS (H)	00H
;	R13	VIDEO RAM START ADDRESS (L)	00
;	R14	CURSOR ADDRESS (H)		00H
;	R15	CURSOR ADDRESS (L)		00

;*** TRY PROGRAMMING EACH REGISTER 16 TIMES***
CRTC:	LXI	D,1000H		;D-COUNT,E-REGISTER #
	LXI	H,RDATA		;REG PROGRAM DATA TABLE
HZ:	IN	KPORT		;MSB OF KPORT IS 50/60 HZ SEL
	ORA	A		;SET MINUS FLAG IF 60 HZ
	JM	RLOOP		;DEFAULT IS 60 HZ
	LXI	H,RDAT1		;IF MSB=0 THEN 50 HZ
RLOOP:	MVI	B,10H		;PROGRAM EACH REG 16 TIMES
R1:	MOV	A,E
	OUT	CADDR		;SEND OUT REGISTER NUMBER
	DCR	B
	JNZ	R1
	MVI	B,10H
R2:	MOV	A,M
	OUT	CDTA		;SEND OUT REGISTER DATA
	DCR	B
	JNZ	R2
	INX	H
	INR	E
	DCR	D		;ALL DONE?
	JNZ	RLOOP
	RET			;CRTC PROGRAMMED

RDATA:	DB	63,40,49,75H	;60 HZ TABLE
	DB	27,08,25,26
	DB	00,08,20H,09
	DB	00H,00,00H,00

RDAT1:	DB	63,40,49,75H	;50 HZ TABLE
	DB	33,06,25,30
	DB	00,08,20H,09
	DB	00H,00,00H,00

;RAM ERASE ROUTINES
ERASE:	LXI	H,VRAM		;ERASE ENTIRE VRAM BY FILLING
	LXI	D,800H		;ALL 2048 CELLS WITH ASCII 20H
	MVI	B,20H		;FILL WITH ASCII BLANK
	CALL	ELOOP
	RET
ERAS1:	LXI	H,SRAM		;ERASE SYSTEM RAM EXCEPT FOR
	LXI	D,700H		;UPPER 100H BYTES
	MVI	B,0		;FILL WITH 00
	CALL	ELOOP
	RET
ELOOP:	MOV	M,B
	INX	H
	DCX	D
	MOV	A,E
	ORA	D
	JNZ	ELOOP
	RET			;RAM ERASED

;PSCAN SUBROUTINE SCANS USER TEXT
;THE MAXIMUM PAGE NUMBER IS STORED IN PMAX
;THE PAGE STARTING ADDRESSES ARE STORED SEQUENTIALLY IN PAGES

PSCAN:	XRA	A
	INR	A
	STA	PMAX		;INITIALIZE PMAX
	LXI	H,TEXT
	SHLD	PAGES		;STORE INDEX PAGE
PLOOP:	MOV	A,M
	CPI	EOF		;ALL DONE
	JZ	DONE
	CPI	']'		;END OF PAGE?
	JZ	ENDPG
	INX	H
	JMP	PLOOP		;GET NEXT CHARACTER
ENDPG:	INX	H
	INX	H		;SKIP CR-LF SEQUENCE
	INX	H
	SHLD	TEMP
	LXI	D,PAGES
	LDA	PMAX
	MVI	H,0
	MOV	L,A
	INR	A
	STA	PMAX
	DAD	H
	DAD	D		;HL HAS TABLE ADDRESS
	XCHG
	LHLD	TEMP		;GET ADDRESS DATA
	XCHG
	MOV	M,E
	INX	H
	MOV	M,D
	XCHG
	INX	H
	JMP	PLOOP
DONE:	LDA	PMAX		;DECREMENT TO ELIMINATE
	DCR	A		;LAST PAGE+1
	DCR	A
	STA	PMAX
	RET			;RETURN TO CALLING PROGRAM

;ASCAN SUBROUTINE SCANS USER TEXT AND ANSWER KEY
;IT LOADS UP THE ANSWER TABLE ANSRS AND GENERATES A MACHINE-
;READABLE ANSWER KEY FOR EACH PAGE

ASCAN:	XRA	A		;INTIIALIZE MAX ANSWERS
	STA	AMAX
	LXI	D,ANSR0		;DE POINTS TO ANSWER KEY
	LXI	H,TEXT		;HL POINTS TO TEXT
NLOOP:	MOV	A,M		;LOOK FOR [ SYMBOL
	CPI	EOF		;END OF FILE
	JZ	DON1		;ALL DONE
	CPI	'['
	JZ	ANSKY		;JUMP TO ANSWER KEY ROUTINE
	INX	H
	JMP	NLOOP		;GO BACK FOR MORE
ANSKY:	INX	H
	SHLD	TEMP		;STORE ADDRESS OF 1ST DIGIT
	PUSH	D		;SAVE POINTER TO ANSWER KEYS
	LXI	D,ANSRS
	LDA	AMAX
	MVI	H,0
	MOV	L,A
	INR	A
	STA	AMAX		;UPDATE AMAX
	DAD	H
	DAD	D		;HL POINTS TO ANSRS ADDRESS
	POP	D		;RESTORE ANSWER KEY POINTER
	MOV	M,E
	INX	H
	MOV	M,D		;PUT DE INTO ANSRS TABLE
	CALL	NUMRS		;FIND OUT NUMBER OF ANSWERS
	MOV	A,B
	STAX	D		;STORE NUMBER OF ANSWERS
	INX	D
	LHLD	TEMP		;GET CHARACTER POINTER
ALOOP:	MOV	A,M		;GET CHAR-MUST BE DIGIT
	SUI	30H		;CONVERT TO BINARY FROM ASCII
	MOV	B,A		;SAVE IT
	INX	H
	MOV	A,M		;GET NEXT CHARACTER
	CPI	','		;SINGLE DIGIT?
	JZ	SDIG
	CPI	']'		;SINGLE DIGIT
	JZ	SDIG
DDIG:	SUI	30H		;CONVERT TO BINARY
	MOV	C,A		;SAVE LS DIGIT
	MOV	A,B		;GET MS DIGIT
	ADD	A		;*2
	ADD	A		;*4
	ADD	A		;*8
	ADD	B		;*9
	ADD	B		;*10
	ADD	C		;10*MSD+LSD
	STAX	D		;STORE RESULT
	INX	D
	INX	H
	MOV	A,M		;CHECK NEXT CHAR
	CPI	']'
	JZ	FINIS
	INX	H
	JMP	ALOOP		;LOOK FOR NEXT NUMBER
SDIG:	MOV	C,A
	MOV	A,B
	STAX	D
	INX	D
	MOV	A,C
	CPI	']'
	JZ	FINIS
	INX	H
	JMP	ALOOP
FINIS:	INX	H
	JMP	NLOOP
NUMRS:	MVI	B,0		;COMMA COUNTER
	LHLD	TEMP
COMMA:	MOV	A,M		;GET CHAR
	CPI	','		;COMMA?
	JZ	SUM
	CPI	']'		;END OF KEY?
	RZ
	INX	H
	JMP	COMMA
SUM:	INR	B
	INX	H
	JMP	COMMA
DON1:	RET			;RETURN TO MAIN PROGRAM

;GO IS THE TEXT DISPLAY AND ANSWER PROCESSING
;IT DISPLAYS A PAGE OF TEXT, GETS KEYBOARD INPUT, AND JUMPS
;TO THE NEXT PAGE TO BE DISPLAYED

GO:	XRA	A		;GET FIRST PAGE OF TEXT AND GO
	STA	CCNT		;STORE PAGE0
	LHLD	PAGES		;PAGE POINTERS
	SHLD	CPAGE		;STORE IN RAM
	LHLD	ANSRS		;ANSWER POINTERS
	SHLD	CANSR		;STORE IN RAM
NEWPG:	CALL	ERASE		;ERASE OLD PAGE
	LXI	H,5094		;PERMANENT SCREEN ADDRESS FOR #
	SHLD	SCRAD
	LHLD	CPAGE		;GET NEW PAGE
	MOV	B,H		;TRANSFER TO BC
	MOV	C,L
	CALL	WRITE		;WRITE THE PAGE
	CALL	NEXT		;GET NEXT PAGE ADDRESS
	LDA	CCNT
	LXI	D,PAGES		;GET ABSOLUTE ADDRESS
	MVI	H,0
	MOV	L,A
	DAD	H		;2 BYTES
	DAD	D		;HL NOW POINTS TO ADDRESS
	MOV	A,M
	INX	H
	MOV	H,M	
	MOV	L,A		;HL NOW CONTAINS ADDRESS
	SHLD	CPAGE		;STORE IN RAM
	LDA	CCNT		;GET ADDRESS OF NEXT ANSR KEY
	LXI	D,ANSRS
	MVI	H,0
	MOV	L,A
	DAD	H
	DAD	D
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	SHLD	CANSR		;STORE NEXT ANSWER KEY
	JMP	NEWPG		;ENDLESS LOOP
NEXT:	CALL	FIRST		;START KEYBOARD INPUT
	LDA	CHAR		;GET TOTAL VALID INPUT<99
	LHLD	CANSR		;GET START ADDR OF ANS KEY
	INX	H		;START ADDR OF RELATIVE ANSRS
	MVI	D,0
	MOV	E,A
	DAD	D		;RELATIVE ADDR OF ANSWER
	MOV	A,M
	STA	CCNT		;STORE IN RAM
	RET
FIRST:	CALL	UNKEY		;WAIT FOR NO KEY PRESS
	CALL	KEYIN		;GET FIRST CHARACTER
	CPI	0DH		;IF CR, IGNORE
	JZ	FIRST
	CPI	7FH		;IF DEL, IGNORE
	JZ	FIRST
	SUI	30H		;CONVERT TO BINARY
	LHLD	CANSR
	MOV	B,M		;GET MAX ANSWER VALUE
	INR	B		;MAX+1
	CMP	B		;SINGLE-DIGIT ANSWER TOO BIG?
	JP	FIRST		;IF SO, TRY AGAIN
	STA	CHAR		;STORE BINARY VALUE OF 1ST CHAR
	LHLD	SCRAD		;WRITE TO SCREEN
	CALL	WCHR
SECND:	CALL	UNKEY		;WAIT FOR KEY RELEASE
	CALL	KEYIN		;GET NEXT KEY
	CPI	0DH
	RZ			;ALL DONE 1 DIGIT
	LHLD	SCRAD
	CPI	7FH		;DELETE 1ST CHAR?
	JNZ	CONT
	CALL	ECHR		;ERASE 1ST CHAR
	JMP	FIRST		;GET NEW 1ST CHAR
CONT:	SUI	30H		;2ND NUMBER TO BINARY
	MOV	C,A		;SAVE 2ND NUMBER
	LDA	CHAR		;GET MS DIGIT
	MOV	E,A		;CONVERT TO HEX
	ADD	A
	ADD	A
	ADD	A		;8*A
	ADD	E
	ADD	E		;10*A
	ADD	C		;10*1ST+2ND
	CMP	B		;IS NUMBER TOO LARGE?
	JP	SECND		;TRY AGAIN FOR 2ND
	STA	CHAR		;STORE COMPOSITE NUMBER
	MOV	A,C		;RESTORE 2ND CHAR
	LHLD	SCRAD		;NEXT SCREEN POSITION
	INX	H
	CALL	WCHR		;WRITE 2ND NUMBER
THIRD:	CALL	UNKEY		;WAIT FOR NEW KEY
	CALL	KEYIN		;GET NEW NUMBER
	CPI	0DH		;IF CR, ALL DONE
	RZ
	LHLD	SCRAD
	INX	H
	CPI	7FH		;DELETE
	JNZ	THIRD		;IF NOT DELETE,INVALID KEY
	CALL	ECHR		;ERASE 2ND CHAR
	JMP	SECND		;GO BACK FOR NEW 2ND CHAR

WCHR:	ADI	30H		;CONVERT BIN TO ASCII 30-39H
	MOV	M,A		;WRITE CHAR ON CRT
	RET
ECHR:	MVI	M,20H		;ERASE CHARACTER
	RET

;WRITE ROUTINE PUTS PAGE OF TEXT ON SCREEN
;***BC HAS ADDRESS OF TEXT TO WRITE
WRITE:	LXI	D,LEN		;LINE LENGTH=40 CHARS
	LXI	H,VRAM		;VIDEO RAM ORIGIN
	SHLD	STLIN		;POINTER TO START OF LINE

LLOOP:	LDAX	B		;GET TEXT CHARACTER
	INX	B
	CPI	0DH		;IS IT CARRIAGE RETURN?
	JZ	NEWLN		;IF SO, START NEW LINE
	CPI	'['		;IS IT END OF TEXT DELIMITER?
	RZ			;IF SO, WE ARE DONE
	CPI	61H		;LOWER CASE?
	JP	INVRS		;DISPLAY AS UPPER CASE INVERSE
	JMP	LL
INVRS:	SUI	20H		;CONVERT TO LOWER CASE LETTER
	ORI	80H		;SET MSB FOR POLARITY REVERSAL
LL:	MOV	M,A		;PUT TEXT CHAR IN VIDEO RAM
	INX	H
	JMP	LLOOP		;GO BACK FOR NEXT CHARACTER

NEWLN:	INX	B		;SKIP LINE FEED CHARACTER
	LHLD	STLIN		;GET PREVIOUS LINE START ADDR
	DAD	D		;ADD LINE LENGTH
	SHLD	STLIN		;STORE NEW LINE START ADDRESS
	JMP	LLOOP		;GO BACK FOR NEXT TEXT CHAR

;KEYBOARD ROUTINE
KEYIN:	LXI	H,KTABL		;GET KEYBOARD-ASCII TABLE
	LXI	D,0
KLOOP:	IN	KPORT		;CHECK FOR DATA READY
	MOV	C,A		;SAVE CHAR, JUST IN CASE
	ANI	10H
	JZ	KLOOP		;WAIT FOR DATA
	MOV	A,C		;RESTORE VALID DATA
	ANI	0FH		;JUST 4 LSB'S
	MOV	E,A		;COMPUTE TABLE ADDRESS
	DAD	D
	MOV	A,M		;GET ASCII DATA FROM TABLE
	RET
UNKEY:	IN	KPORT		;CHECK FOR DATA READY
	ANI	10H		;DATA READY BIT
	JNZ	UNKEY		;WAIT UNTIL NO KEY PRESSED
	RET


KTABL:	DB	7FH,'0',0DH,00,'1'
	DB	'2','3',00,'4','5'
	DB	'6',00,'7','8','9'

	END	PROMPT
	
	